function varargout=solve(bvp,varargin)
% 
% lambda=solve(bvp,varargin)
% [lambda,U]=solve(bvp,varargin)
% lambda=solve(bvp,Bop,varargin)
% [lambda,U]=solve(bvp,Bop,varargin)
% 
% Where varargin are the options of eigs function
% If Bop not specified then by default used
%   Bop=Loperator(bvp.dim,bvp.d,[],[],[],1) if bvp.m==1
% ...
%
% samples
%   [eVec,eVal]=solve(bvp,5,'sm');
%
  assert(ismember(nargout,[1,2,3]))
  [A,~]=bvp.Assembly('Dirichlet',false);%,'local',true);
  [ID,IDc,gD]=bvp.AssemblyDirichlet();
  if strcmp(class(varargin{1}),'Loperator') || strcmp(class(varargin{1}),'Hoperator')
    Bop=varargin{1};varargin=varargin{2:end};
  else
    Lop=Loperator(bvp.dim,bvp.d,[],[],[],1);
    if bvp.m==1
      Bop=Lop;
    else
      Bop=Hoperator(bvp.dim,bvp.dim,bvp.dim);
      for i=1:bvp.dim, Bop.set(1,1,Lop);end 
    end
  end
  bvpRHS=BVP(bvp.Th,PDEelt(Bop));
  [B,~]=bvpRHS.Assembly();%'local',true);
%    if nargout==1
%      if isempty(ID)
%        eigenvalues = eigs(A,B,varargin{:});
%      else
%        eigenvalues = eigs(A(IDc,IDc),B(IDc,IDc),varargin{:});
%      end
%    else
%      if isempty(ID)
%        [eigenvectors2,eigenvalues] = eigs(A,B,varargin{:});
%      else
%        [eigenvectors2,eigenvalues] = eigs(A(IDc,IDc),B(IDc,IDc),varargin{:});
%      end
%    end
  varargout=cell(nargout,1);
  if isempty(ID)
    [varargout{:}]=eigs(A,B,varargin{:});
  else
    [varargout{:}]=eigs(A(IDc,IDc),B(IDc,IDc),varargin{:});
    if nargout>1
      NumEigs=length(varargout{2});
      eigenvectors=zeros(bvp.ndof,NumEigs);
      eigenvectors(IDc,:) = fliplr(varargout{1});
      varargout{1}=eigenvectors;
    end
  end
%    if nargout>2
%    NumEigs=length(eigenvalues);
%    % sort eigenvalues 
%    [eigenvalues,I] = sort(flipud(diag(eigenvalues)));
%    varargout{1}=eigenvalues;
%    if nargout==1,return;end
%    
%    eigenvectors3=zeros(bvp.ndof,NumEigs);
%    eigenvectors3(IDc,:) = fliplr(eigenvectors2);
%    eigenvectors3=eigenvectors3(:,I);
%    
%    if bvp.m>1
%       for i=1:NumEigs
%         eigenvectors{i}=bvp.splitsol(eigenvectors3(:,i));
%       end
%    else
%      eigenvectors=eigenvectors3;
%    end
%    varargout{2}=eigenvectors;
end